<?php
/*
Plugin Name: dashborad_view_multisite
Description:ダッシュボードにマルチサイトの情報を表示するプラグインです。
Version: 0.1
Author: Y.ikeda
Author URI: http://55w.jp
*/



// ダッシュボードにマルチサイト情報を出力

function dashboard_multisite_widget_function() {
global $wpdb;
if ( !is_multisite() ){echo 'このサイトはマルチサイトではありません';return;}
if ( ! current_user_can('read') ){echo 'サイトを表示する権限がありません';return;}	

	echo '<table class="widefat fixed">';
		$ids = $wpdb->get_results("SELECT blog_id FROM $wpdb->blogs");
		$user = wp_get_current_user();
		foreach($ids as $id){
			$blog_id = $id->blog_id;
			$blogs = get_blog_details($blog_id);
			$dashboard = $blogs->siteurl . "/wp-admin/";
			$blogusers = get_users_of_blog($blog_id);
			$blog_user_check =0;
			foreach($blogusers as $key => $val){
				if($val->user_login == $user->user_login){$blog_user_check=1;}
			}
			
			if($blog_user_check){
				echo "<tr><td>";
				echo "<h3>{$blogs->blogname}</h3>";
				echo "<p><a href='{$blogs->siteurl}'>表示</a>|";
				echo "<a href='$dashboard'>ダッシュボード</a>";
				switch_to_blog($blog_id);
						global $wpdb;		
						$num_posts = wp_count_posts( 'post' );
						$num = number_format_i18n( $num_posts->publish );
						$text = "|投稿($num)";
						if ( current_user_can( 'edit_posts' ) ) {$text = "<a href='{$dashboard}edit.php'>{$text}</a>";}
						echo $text;
	
						$num_pages = wp_count_posts( 'page' );
						$num = number_format_i18n( $num_pages->publish );	
						$text = "|ページ($num)";
						if ( current_user_can( 'edit_pages' ) ) {$text = "<a href='{$dashboard}edit.php?post_type=page'>{$text}</a>";}
						echo $text;
						
						/*カスタム投稿も出力。現在調整中
						$sql  = "SELECT post_type FROM $wpdb->posts GROUP BY post_type ";
						$sql .= "HAVING post_type != 'page' AND post_type != 'post' AND post_type != 'revision' AND post_type != 'attachment'";
						$posttype_names = $wpdb->get_results($sql);
						foreach($posttype_names as $value)
							{
								$post_type_object = get_post_type_object($value->post_type);
								$num_cpost = wp_count_posts($value->post_type);
								$num  = number_format_i18n( $num_cpost->publish );
								$text = "|{$post_type_object->labels->name}({$num})";
								if ( current_user_can( 'edit_posts' ) ) {$text = "<a href='{$dashboard}edit.php?post_type={$value->post_type}'>{$text}</a>";}
								echo $text;
							}
						*/
				restore_current_blog();
										
				echo "</p></td></tr>";
			}
		}
	echo "</table>";
} 

// アクションフックで使用する関数を作成する

function add_multi_dush_widgets() {
	wp_add_dashboard_widget('dashboard_multisite', 'マルチサイト', 'dashboard_multisite_widget_function');	
} 

// 'wp_dashboard_setup' アクションにフックし、登録する

add_action('wp_dashboard_setup', 'add_multi_dush_widgets' );

?>